#include <bits/stdc++.h>

using namespace std;


int n;
struct unos{
    char c;
    int m;
};
int mat[10004][82];
unos nesto[10004];

void resenje () {

}

int main () {
    scanf("%d",&n);
    scanf("%d %d %d %d",&mat[0]['O'],&mat[0]['A'],&mat[0]['B'],&mat[0]['C']);
    for(int i=1;i<=n;i+=1){
        cin>>nesto[i].c>>nesto[i].m;
    }

    cout<<"nemoguce"<<endl;

    return 0;
}